/*
 * MicroMarketRefConverter.java
 * 
 * Created on Apr 17, 2007, 6:04:41 PM
 * 
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package test.converter;

import java.net.URI;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlAttribute;
import test.MicroMarket;

/**
 *
 * @author lukas
 */
@XmlRootElement(name = "microMarketRef")
public class MicroMarketRefConverter {
    private MicroMarket entity;
    private boolean isUriExtendable;
    private URI uri;

    public MicroMarketRefConverter() {
    }

    /**
     * Creates a new instance of MicroMarketRefConverter.
     *
     * @param entity associated entity
     * @param uri associated uri
     * @param isUriExtendable indicates whether the uri can be extended
     */

    public MicroMarketRefConverter(MicroMarket entity, URI uri,
                                   boolean isUriExtendable) {
        this.entity = entity;
        this.uri = uri;
        this.isUriExtendable = isUriExtendable;
    }

    /**
     * Getter for zipCode.
     *
     * @return value for zipCode
     */

    @XmlElement
    public String getZipCode() {
        return entity.getZipCode();
    }

    /**
     * Returns the URI associated with this reference converter.
     *
     * @return the converted uri
     */

    @XmlAttribute
    public URI getUri() {
        if (isUriExtendable) {
            return uri.resolve(getZipCode().toString() + "/");
        }
        return uri;
    }

    /**
     * Sets the URI for this reference converter.
     *
     */

    public void setUri(URI uri) {
        this.uri = uri;
    }

    /**
     * Returns the MicroMarket entity.
     *
     * @return MicroMarket entity
     */

    @XmlTransient
    public MicroMarket getEntity() {
        MicroMarketConverter result = UriResolver.getInstance().resolve(MicroMarketConverter.class,
                                                                        uri);

        if (result != null) {
            return result.getEntity();
        }
        return null;
    }

}
