/*
 * MicroMarketsConverter.java
 * 
 * Created on Apr 17, 2007, 6:04:41 PM
 * 
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package test.converter;

import java.net.URI;
import java.util.Collection;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import java.util.ArrayList;
import test.MicroMarket;

/**
 *
 * @author lukas
 */
@XmlRootElement(name = "microMarkets")
public class MicroMarketsConverter {
    private Collection<MicroMarket> entities;
    private URI uri;

    public MicroMarketsConverter() {
    }

    /**
     * Creates a new instance of MicroMarketsConverter.
     *
     * @param entities associated entities
     * @param uri associated uri
     */

    public MicroMarketsConverter(Collection<MicroMarket> entities, URI uri) {
        this.entities = entities;
        this.uri = uri;
    }

    /**
     * Returns a collection of MicroMarketRefConverter.
     *
     * @return a collection of MicroMarketRefConverter
     */

    @XmlElement(name = "microMarketRef")
    public Collection<MicroMarketRefConverter> getReferences() {
        if (entities != null) {
            Collection<MicroMarketRefConverter> refs = new ArrayList<MicroMarketRefConverter>();

            for (MicroMarket entity : entities) {
                refs.add(new MicroMarketRefConverter(entity, uri, true));
            }
            return refs;
        }
        return null;
    }

    /**
     * Sets a collection of MicroMarketRefConverter.
     *
     * @param a collection of MicroMarketRefConverter to set
     */

    public void setReferences(Collection<MicroMarketRefConverter> refs) {
        if (refs != null) {
            entities = new ArrayList<MicroMarket>();
            for (test.converter.MicroMarketRefConverter ref : refs) {
                entities.add(ref.getEntity());
            }
        }
    }

    /**
     * Returns a collection MicroMarket entities.
     *
     * @return a collection of MicroMarket entities
     */

    @XmlTransient
    public Collection<MicroMarket> getEntities() {
        return entities;
    }

}
